/***************************************************************
 * Name:      wx002Main.cpp
 * Purpose:   Code for Application Frame
 * Author:    Salvador Pozo (salvapozo@gmail.com)
 * Created:   2024-04-11
 * Copyright: Salvador Pozo (https://conclase.net)
 * License:
 **************************************************************/

#ifdef WX_PRECOMP
#include "wx_pch.h"
#endif

#include "wx002Main.h"
#include "nosalir16x16.xpm"
#include "salir16x16.xpm"

//helper functions
enum wxbuildinfoformat {
    short_f, long_f };

wxString wxbuildinfo(wxbuildinfoformat format)
{
    wxString wxbuild(wxVERSION_STRING);

    if (format == long_f )
    {
#if defined(__WXMSW__)
        wxbuild << _T("-Windows");
#elif defined(__WXMAC__)
        wxbuild << _T("-Mac");
#elif defined(__UNIX__)
        wxbuild << _T("-Linux");
#endif

#if wxUSE_UNICODE
        wxbuild << _T("-Unicode build");
#else
        wxbuild << _T("-ANSI build");
#endif // wxUSE_UNICODE
    }

    return wxbuild;
}


BEGIN_EVENT_TABLE(wx002Dialog, wxDialog)
    EVT_CLOSE(wx002Dialog::OnClose)
    EVT_BUTTON(idBtnQuit, wx002Dialog::OnQuit)
    EVT_BUTTON(idBtnAbout, wx002Dialog::OnAbout)
END_EVENT_TABLE()

wx002Dialog::wx002Dialog(wxDialog *dlg, const wxString &title)
    : wxDialog(dlg, -1, title)
{
    wxImage::AddHandler(new wxPNGHandler);
    this->SetSize(320, 150);

    m_staticText1 = new wxStaticText(this, wxID_ANY, wxT("Bienvenido a\nwxWidgets"), wxPoint(30,30), wxSize(180,200), 0);
    m_staticText1->SetFont(wxFont(20, wxFONTFAMILY_ROMAN, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_THIN, false, wxT("Arial")));
    BtnAbout = new wxButton(this, idBtnAbout, wxT("&Sobre"), wxPoint(220, 20), wxDefaultSize, 0);
    BtnAbout->SetDefault();
    new wxStaticLine(this, wxID_ANY, wxPoint(180,50), wxSize(130,3), wxLI_HORIZONTAL);
    BtnQuit = new wxButton(this, idBtnQuit, wxT("S&alir"), wxPoint(220,60), wxDefaultSize, 0);
    this->SetEscapeId(idBtnQuit);
    BtnQuit->SetBitmap(salir16);
    BtnQuit->SetBitmapDisabled(nosalir16);
    BtnQuit->Disable();
    //BtnQuit->Hide();
}


wx002Dialog::~wx002Dialog()
{
}

void wx002Dialog::OnClose(wxCloseEvent &event)
{
    if(BtnQuit->IsEnabled()) Destroy();
}

void wx002Dialog::OnQuit(wxCommandEvent &event)
{
    Destroy();
}

void wx002Dialog::OnAbout(wxCommandEvent &event)
{
    wxString msg = wxbuildinfo(long_f);
    wxMessageBox(msg, _("Bienvenido a..."));
    BtnQuit->Enable();
    //BtnQuit->Show();
}
